#define DELAY_SIZE 10

boolean matrix[8][8]={
{0,0,0,1,1,0,0,0},
{0,0,1,0,0,1,0,0},
{0,1,0,0,0,0,1,0},
{0,1,0,0,0,0,1,0},
{0,1,0,0,0,0,1,0},
{0,1,1,1,1,1,1,0},
{0,1,0,0,0,0,1,0},
{0,1,0,0,0,0,1,0}
};

int delay_time[]={500,100,50,30,20,10,5,3,2,1};
int dt_rc=0;
int delay_rc=32;

void setup(){
  for(int i=2;i<=17;i++){
    pinMode(i,OUTPUT);
    digitalWrite(i,HIGH);
  }
}
void loop(){
  for(int i=2;i<=9;i++){
    digitalWrite(i,LOW);  //行：LOWで点灯  
    for(int j=10;j<=17;j++){
      if(matrix[i-2][j-10]==1){//点灯条件
        digitalWrite(j,HIGH);   //列：HIGHで点灯
      }
      else
        digitalWrite(j,LOW);//オフにする
    }
    delay(delay_time[dt_rc]); //一定時間点灯
    if( (delay_rc<=0) && (dt_rc<(DELAY_SIZE-1)) ){
      dt_rc+=1;
      delay_rc=5000/delay_time[dt_rc];
    }
    delay_rc-=1;
    for(int j=10;j<=17;j++)
      digitalWrite(j,LOW);
    digitalWrite(i,HIGH);//オフにする
  }

}
